#flythrough.rb
#Auther :TAK2HATA
#version1.0
#Update Mar 20,2013.
#site: http://sketchup-onigiri.jimdo.com/
###日本語
#General disclaimer
#I MAKES NO GUARANTEE OF VALIDITY about this script.
#Please use this script at your own risk.
##免責事項
##このスクリプトによって如何なる損害が発生しても製作者は責任を負いません。各人の責任においてご使用ください。

class TAK_FlyThrough
	class TAK_view_animation
		def initialize( flylength,shift,keypress)
			@flylength1 = flylength
			@flylength1 = @flylength1 * 2 if shift == true
			@upkey1 = keypress["UP"]
			@downkey1 = keypress["DOWN"]
			@rightkey1 = keypress["RIGHT"]
			@leftkey1 =keypress["LEFT"]
			@homekey1 =keypress["HOME"]
			@endkey1 =keypress["END"]
		end
		def nextFrame(view)
			camera = view.camera
			cdir = camera.direction.normalize
			up = camera.up.normalize
			mvec = Geom::Vector3d.new(0,0,0)
			if @upkey1 == true
				mvec = mvec + cdir
			end
			if @downkey1 == true
				mvec = mvec + cdir.reverse
			end
			if @leftkey1 == true
				mvec = mvec + cdir.cross( up ).reverse.normalize
			end
			if @rightkey1 == true
				mvec = mvec + cdir.cross( up ).normalize
			end
			if @homekey1 == true
				mvec = mvec + Geom::Vector3d.new(0,0,1)
			end
			if @endkey1 == true
				mvec = mvec + Geom::Vector3d.new(0,0,-1)
			end
			return if mvec == Geom::Vector3d.new(0,0,0)
			mvec.length = @flylength1
			eye = view.camera.eye + mvec
			target = view.camera.target + mvec
			view.camera.set( eye, target , view.camera.up )
			view.show_frame
		end
	end
	
	def draw(view)
		Sketchup.set_status_text( "[ARROW] to MOVE, [L-Drag] to Look Around,[SHIFT] to RUN,[TAB] to change SPEED" )
	end
	def initialize
		@flylength = 0.3.m
		a = Sketchup.read_default("TAK2_FLYTHROUGH","FLYLENGTH","0.3.m")
		@flylength = a.to_l if a
		#@flylength = 0.2.m
		reset
	end
	def reset
		@keypress = Hash.new
		@keypress["UP"] = false
		@keypress["DOWN"] = false
		@keypress["LEFT"] = false
		@keypress["RIGHT"] = false
		@keypress["HOME"] = false
		@keypress["END"] = false
		@shift = false
		@lbtndn = false

		@cxy = [ 0,0 ]
		Sketchup.active_model.active_view.animation = nil
	end
	def activate
		Sketchup.set_status_text( "ARROW to MOVE,L-Drag to Look Around,Press [SHIFT] to RUN,[TAB] to change SPEED" )
	end
	def deactivate(view)
	end
	
	def onCancel(flag, view)
		reset
		Sketchup.active_model.select_tool nil
	end
	def onMouseMove(flags, x, y, view)
		if @lbtndn == true
			px , py = @cxy
			model = Sketchup.active_model
			camera = view.camera
			cdir = camera.direction.normalize
			fov = camera.fov
			up = camera.up
			eye = camera.eye
			target = camera.target
			plane = [ target , cdir ]
			ray1 = view.pickray( px , py )
			ray2 = view.pickray( x , y )
			opt = Geom.intersect_line_plane( ray1 , plane )
			npt = Geom.intersect_line_plane( ray2 , plane )
			target = target + opt.vector_to(npt)
			up = Geom::Vector3d.new(0,0,1).cross( eye.vector_to(target) ).cross( eye.vector_to(target) ).reverse
			view.camera.set( eye, target , up )
			@cxy = [ x,y ]
		end
	end
	def onKeyDown(key, repeat, flags, view)
		case key
		when VK_UP
			@keypress["UP"] = true
		when VK_DOWN
			@keypress["DOWN"] = true
		when VK_RIGHT
			@keypress["RIGHT"] = true
		when VK_LEFT
			@keypress["LEFT"] = true
		when 36
			@keypress["HOME"] = true
		when 35
			@keypress["END"] = true
		when VK_SHIFT
			@shift = true
		when 9
			 res = UI.inputbox ["FLY SPEED"],[@flylength.to_s],"CHANGE FLYING SPEED"
			 if res
				if res[0].to_l != 0.0
					@flylength = res[0].to_l
					p @flylength
					Sketchup.write_default("TAK2_FLYTHROUGH","FLYLENGTH", @flylength.to_s )
				end
			 end
		end
		if @keypress.values.index( true )
			Sketchup.active_model.active_view.animation = TAK_view_animation.new( @flylength , @shift , @keypress )
		else
			reset
		end
	end
	def onKeyUp(key, repeat, flags, view)
		case key
		when VK_UP
			@keypress["UP"] = false
		when VK_DOWN
			@keypress["DOWN"] = false
		when VK_RIGHT
			@keypress["RIGHT"] = false
		when VK_LEFT
			@keypress["LEFT"] = false
		when 36
			@keypress["HOME"] = false
		when 35
			@keypress["END"] = false
		when VK_SHIFT
			@shift = false
		else
			reset
		end
		if @keypress.values.index( true )
			Sketchup.active_model.active_view.animation = TAK_view_animation.new( @flylength , @shift , @keypress )
		else
			reset
		end
	end
	def onLButtonUp(flags, x, y, view)
		@lbtndn = false
	end
	def onLButtonDown(flags, x, y, view)
		@lbtndn = true
		@cxy = [ x,y ]
	end
end

unless( file_loaded?( "flythrough.rb" ) )
	UI.menu("Plugins").add_item( "FlyThrough Mode"){
		Sketchup.active_model.select_tool TAK_FlyThrough.new
	}
end
file_loaded("flythrough.rb")